unit FTPClient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Winsock, mmsystem;

const

     TAM_PAQUET=8192;
     TAM_PAQUET2=4096;
     WM_USERHOST=1026;
     WM_USER=1024;
     WM_USERLIST=1027;
     winsocket = 'wsock32.dll';
    function WSAFDIsSet(s: TSOcket; var FDSet: TFDSet): Bool; stdcall;
    function FD_ISSET(Socket: TSocket; var FDSet: TFDSet): Boolean;
    procedure FD_SET(Socket: TSocket; var FDSet: TFDSet);
    procedure FD_ZERO(var FDSet: TFDSet);

type

  TInfoEvent = procedure(Sender: TObject; Info:string) of object;

  TTxTypes=(Binary,ASCII,Auto);

  TFTPClient = class(TComponent)
  private
    { Private declarations }
     esticconnectant:boolean;
     fhandle:HWND;
     EsticenWSA,Estoyenello,cancelat:boolean;
     fsoundfile,liststr,fuser,fpass,fhost:string;
     finformation,ipmostrat,directorimostrat:string;
     ftype:ttxtypes;
     socketmostrat,fport:integer;
     WSData:TWSAData;
     
     ferror,fconnected,ffileget,ffileput,fclosed:TNotifyEvent;
     finformationevent:Tinfoevent;

     procedure SetInfo(i:string);
     procedure beeps;
     procedure WMUSER(var Tm:tmessage);message WM_USER;
     procedure WMUSERLIST(var Tm:tmessage);message WM_USERLIST;
     procedure WMUSERHOST(var Tm:tmessage);message WM_USERHOST;
     function ConnectarAServidor(serv,user,passwd:string;FTPPort:integer):boolean;
     function AcceptaSocket(s:integer):integer;
     function EnviarComanda(s:integer;comanda:string):boolean;
     function RetornaAsteriscs(cad:string):string;
     function LlegirLinia(s:integer):string;
     function getListenSocket(s:integer):integer;
     function ComprobarREST(s:integer;ipactual:string):boolean;
     function ExtreuDirNet(dir:string):string;
     function EsperaWSA(s,event:integer):integer;
     function EsperaWSAList(s,event:integer):integer;
     procedure RessetejaWSA(s:integer);
     procedure TraduirLIST(s:integer);
     procedure WndProc(var Message: TMessage);
     procedure SeleccionaTYPE(s:integer;arxiu:string);

     function fesPWD(s:integer):string;
     function fesPORT(s,ip1,ip2,ip3,ip4,port1,port2:integer):integer;
     function fesTYPE(s:integer;c:char):boolean;
     function fesLIST(s:integer; dir,serv:string):string;
     function fesRMD(s:integer;dir:string):boolean;
     function fesMKD(s:integer;dir:string):boolean;
     function fesCDUP(s:integer):boolean;
     function fesCWD(s:integer;dir:string):boolean;
     function fesDELETEFILE(s:integer;nom:string):boolean;
     function fesQUIT(s:integer):boolean;
     function fesRENAME(s:integer;origen,desti:string):boolean;
     function fesAbort(s:integer):boolean;
     function fesPUT(s:integer; arxiuorigen,arxiudesti:string):boolean;
     function fesGET(s:integer; arxiuorigen,arxiudesti:string):boolean;
     function fesSYST(s:integer):string;
     function fesNOOP(s:integer):boolean;

  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property information:string read finformation write setinfo;
    property Handle:HWND read fhandle write fhandle;
    property WorkingDirectory:string read directorimostrat;
    property LastList:string read liststr;
    property Waiting:boolean read EsticEnWSA;

    function MKD(DirName:string):boolean;
    function PWD:string;
    function RMD(DirName:string):boolean;
    function CWD(DirName:string):boolean;        
    function CDUP:boolean;
    function FTPConnect:boolean;
    function Open(Host,User,Pass:string;Port:integer):boolean;
    function LIST(DirName:String):string;
    function DeleteFile(FileName:String):boolean;
    function Quit:boolean;
    function RenameFile(OldName,NewName:string):boolean;
    function Abort:boolean;
    procedure Cancel;
    function Put(LocalFile,RemoteFile:string):boolean;
    function Get(RemoteFile,LocalFile:string):boolean;
    function System:string;
    function NOOP:boolean;
    function CustomCommand(Command:string):string;

  published
    { Published declarations }
    property SoundFile:string read fsoundfile write fsoundfile;
    property User:string read fuser write fuser;
    property Password:string read fpass write fpass;
    property Host:string read fhost write fhost;
    property Port:integer read fport write fport;
    property DataType:TTxtypes read ftype write ftype;

    property OnError:TNotifyEvent read ferror write ferror;
    property OnInformation:TinfoEvent read finformationevent write finformationevent;
    property OnConnected:TNotifyEvent read fconnected write fconnected;
    property OnConnectionClosed:TNotifyevent read fclosed write fclosed;
    property OnFileGet:TNotifyevent read ffileget write ffileget;
    property OnFilePut:TNotifyevent read ffileput write ffileput;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('UsefulTools', [TFTPClient]);
end;

constructor tftpclient.create(AOwner:TComponent);
begin
  inherited Create(Aowner);
  FHandle := AllocateHWnd(WndProc);
  //aqu falten tots els valors per defecte
  fport:=21;
  fuser:='';
  fpass:='';
  fhost:='';
  cancelat:=false;
  estoyenello:=false;
  esticconnectant:=false;
  ipmostrat:='';
  socketmostrat:=-1;
  directorimostrat:='';
  information:='';
  fsoundfile:='';
  liststr:='';
  ftype:=auto;
  WSAStartup(MAKEWORD(1,1),WSData);
end;

destructor tftpclient.destroy;
begin
     inherited Destroy;
     DeallocateHWnd(FHandle);
end;

function TFTPclient.ConnectarAServidor(serv,user,passwd:string;FTPPort:integer):boolean;
var
   len,s:integer;
   nr:longint;
   addr,peer:TSockAddrIn;
   success:boolean;
   ip,bufstr,buf3,buf,dir:string;
   hpa:array[0..1024]of char;
begin
     //per a connectar amb un servidor FTP
     esticconnectant:=true;
     result:=true;
     information:='>Connecting socket to '+serv;
     s:=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
     if s=INVALID_SOCKET then
     begin
          //error
          information:='>ERROR '+inttostr(WSAGetLastError)+' : socket not connected.';
          closesocket(s);
          result:=false;
          esticconnectant:=false;
          beeps;
          exit;
     end;
         addr.sin_family:=AF_INET;
         addr.sin_port:=htons(FTPPort);
         if ((serv[1]>='0')and(serv[1]<='9')) then
         begin
              //s un nombre 123.12.32.47
              ip:=serv;
              addr.sin_addr.s_addr:=inet_addr(pchar(serv));
         end else
         begin
              //s un nom www.waveflow.com
                EsticenWSA:=true;
                hpa:='';
                WSAAsyncGetHostByName(handle,WM_USERHOST,pchar(serv),hpa,length(hpa));
//-----ooooo
                while EsticEnWSA do
                begin
                     if (cancelat) then
                     begin
                          closesocket(s);
                          information:='--CANCELED--';
                          beeps;
                          result:=false;
                          esticconnectant:=false;
                          exit;
                     end;
                application.processmessages;
                end;
                if WSAAsyncSelect(s,handle,0,0)=SOCKET_ERROR then
                begin
                     //error
                     information:='>ERROR '+inttostr(WSAGetLastError)+' WSAAsyncSelect';
                     beeps;
                     result:=false;
                     esticconnectant:=false;
                     closesocket(s);
                     exit;
                end;
                nr:=0;
                ioctlsocket(s,FIONBIO,nr);                   //blocking
//-----ooooo
              ip:=inttostr(ord(hpa[28]))+'.'
                  +inttostr(ord(hpa[29]))+'.'
                  +inttostr(ord(hpa[30]))+'.'
                  +inttostr(ord(hpa[31]));
              addr.sin_addr.s_addr:=inet_addr(pchar (ip));
         end;
     EsticEnWSA:=true;
     if WSAAsyncSelect(s,handle,1024,FD_CONNECT)=SOCKET_ERROR then
     begin
         //error
         closesocket(s);
         beeps;
         result:=false;
         esticconnectant:=false;
         information:='>ERROR '+inttostr(WSAGetLastError)+' : socket not connected.';
         exit;
     end;
     connect(s,addr,sizeof(addr));
     while EsticEnWSA do
     begin
          if (cancelat) then
          begin
               closesocket(s);
               information:='--CANCELED--';
               beeps;
               result:=false;
               esticconnectant:=false;
               exit;
          end;
           application.processmessages;
     end;
     if WSAAsyncSelect(s,handle,0,0)=SOCKET_ERROR then
     begin
          //error
          information:='>ERROR '+inttostr(WSAGetLastError)+' WSAAsyncSelect';
          beeps;
          closesocket(s);
          result:=false;
          esticconnectant:=false;
          exit;
     end;
     nr:=0;
     ioctlsocket(s,FIONBIO,nr);                   //blocking
     //Ara amb lo del WSA no puc saber si el socket est connectat o no (error)...
     //probar aix a veure qu...
     nr:=0;
     len:=sizeof(peer);
     nr:=getpeername(s,peer,len);
     if nr<>0 then
     begin
         //error
         closesocket(s);
         beeps;
         nr:=WSAGetLastError;
         information:='>ERROR '+inttostr(nr)+' : socket not connected.';
         if cancelat then
         begin
            information:='--CANCELED--';
         end;
         result:=false;
         exit;
         esticconnectant:=false;
     end;       
     //...doncs a veure...
     information:='>Socket connected.';
     buf:=llegirlinia(s);
     if (cancelat)or(length(buf)<4) then
     begin
          closesocket(s);
          information:=('--CANCELED--');
          beeps;
          result:=false;
          esticconnectant:=false;
          exit;
     end;
     if buf[1]<>'2' then
     begin
          closesocket(s);
          information:=('--->'+buf+' Service Unavailable');
          beeps;
          result:=false;
          esticconnectant:=false;
          exit;
     end;
     information:=('--->'+buf);
     bufstr:=buf;
     while buf[4]='-' do        //pot ser que el missatge de benvinguda
     begin                      //ocupi ms d'una linia
          //falten linies
          buf:=llegirlinia(s);
          if cancelat then
          begin
               closesocket(s);
               information:=('--CANCELED--');
               beeps;
               result:=false;
               esticconnectant:=false;
               exit;
          end;
          information:=('--->'+buf);
          bufstr:=bufstr+#13+buf;
     end;

     success:=false;
     if not EnviarComanda(s,'USER '+user+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
     begin
          closesocket(s);
          information:=('--CANCELED--');
          esticconnectant:=false;
          result:=false;
          beeps;
          exit;
     end;
     information:=('>USER '+user);
     information:=('--->'+buf);
     if ((buf[1]='1')or(buf[1]='4')or(buf[1]='5')) then //error
     begin
          information:=('>ERROR with USER');
     end else
     if buf[1]='3' then //need password
     begin
          if not EnviarComanda(s,'PASS '+passwd+#13+#10) then exit;
          information:=('>PASS '+retornaasteriscs(passwd));
          buf3:=llegirlinia(s);
          if cancelat then
          begin
               closesocket(s);
               information:=('--CANCELED--');
               beeps;
               result:=false;
               esticconnectant:=false;
               exit;
          end;
          information:=('--->'+buf3);
          if bufstr<>'' then
             bufstr:=bufstr+#13+buf3;
          while buf3[4]='-' do        //pot ser que el missatge de benvinguda
          begin                      //ocupi ms d'una linia
                //falten linies
                buf3:=llegirlinia(s);
                if cancelat then
                begin
                     closesocket(s);
                     information:=('--CANCELED--');
                     beeps;
                     result:=false;
                     esticconnectant:=false;
                     exit;
                end;
                information:=('--->'+buf3);
                bufstr:=bufstr+#13+buf3;
          end;
          if ((buf3[1]='1')or(buf3[1]='4')or(buf3[1]='5')) then
          begin
               information:=('>ERROR with password');
          end else
          if buf3[1]='3' then
          begin
               //faltaria el ACCT
          end else
          begin
               success:=true;
          end;
     end else
     begin
          success:=true;
     end;
     if success then
     begin
          //user logged in
          beeps;        //benvinguda WELCOME
          showmessage(bufstr);
          dir:=fesPWD(s);  //miro quin es el directori arrel
          if cancelat then
          begin
               closesocket(s);
               information:=('--CANCELED--');
               beeps;
               result:=false;
               esticconnectant:=false;
               exit;
          end;
          fesTYPE(s,'A');  //canvio a ASCII
          if cancelat then
          begin
               closesocket(s);
               information:=('--CANCELED--');
               beeps;
               result:=false;
               esticconnectant:=false;
               exit;
          end;
          ipmostrat:=ip;
          dir:=fesLIST(s,dir,serv); //el tree node estar a l'arrel (nil)
          if cancelat then
          begin
               //closesocket(s);
               result:=false;
               esticconnectant:=false;
               exit;
          end;
          esticconnectant:=false;
          result:=true;
          comprobarrest(s,ip);
     end else
     begin
               esticconnectant:=false;
               closesocket(s);
               result:=false;
               information:=('--NOT CONNECTED-- ');
               beeps;
     end;
end;

function TFTPclient.fesPWD(s:integer):string;
var
   buf:string;
   i:integer;
begin
     result:='';
     if not EnviarComanda(s,'PWD'+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>PWD');
     information:=('--->'+buf);
     if buf[1]='2' then
     begin
          for i:=6 to length(buf) do
          begin
               if buf[i]='"' then break;
               result:=result+buf[i];
          end;
     end;

     directorimostrat:=ExtreuDirnet(result)+'/'; //per si a cas
     socketmostrat:=s;
end;

function TFTPclient.getListenSocket(s:integer):integer;
var
 {  fd:TFDSET;
   timeo:Ttimeval;  }
   e,sd,len:integer;
   serv_addr,temp_addr:TSockAddrIn;
   port:integer;
   ip:integer;
   ip1,ip2,ip3,ip4,port1,port2:integer; //el 4 s el de menor pes
begin
//creo el socket
sd:=socket(AF_INET,SOCK_STREAM,0);
if (sd=INVALID_SOCKET) then
begin
     closesocket(sd);
     information:=('>ERROR '+inttostr(WSAGetLastError)+' : data socket not connected.');
     result:=INVALID_SOCKET;
     beeps;
     exit;
end;
serv_addr.sin_family:=AF_INET;
serv_addr.sin_addr.s_addr:=htonl(INADDR_ANY);
serv_addr.sin_port:=htons(0);
//faig el bind
e:=bind(sd,serv_addr,sizeof(serv_addr));
if (e=SOCKET_ERROR) then
begin
     closesocket(sd);
     information:=('>ERROR '+inttostr(WSAGetLastError)+' : data socket not connected.');
     result:=INVALID_SOCKET;
     beeps;
     exit;
end;
len:=sizeof(serv_addr);
if(getsockname(sd,serv_addr,len)=SOCKET_ERROR) then
begin
     closesocket(sd);
     information:=('>ERROR '+inttostr(WSAGetLastError)+' : data socket not connected.');
     result:=INVALID_SOCKET;
     beeps;
     exit;
end;
len:=sizeof(temp_addr);
if(getsockname(s,temp_addr,len)=SOCKET_ERROR) then
begin
     closesocket(sd);
     information:=('>ERROR '+inttostr(WSAGetLastError)+' : data socket not connected.');
     result:=INVALID_SOCKET;
     beeps;
     exit;
end;
port:=serv_addr.sin_port;
ip:=temp_addr.sin_addr.S_addr;
//faig el listen
if(listen(sd,1)=SOCKET_ERROR) then
begin
     closesocket(sd);
     information:=('>ERROR '+inttostr(WSAGetLastError)+' : data socket not connected.');
     result:=INVALID_SOCKET;
     beeps;

     exit;
end;
//Aix s nou
//m'asseguro de que estigui tot llegit i no m'equivoqui
{RessetejaWSA(s);
FD_ZERO(fd);
FD_SET(s,fd);
timeo.tv_usec:=100;
timeo.tv_sec:=0;
select(0,@fd,nil,nil,@timeo);
if fd_ISSET(s,fd) then
   llegirlinia(s);  }
//fins aqui;
ip1:=ip and $FF;
ip2:=(ip shr 8) and $FF;
ip3:=(ip shr 16) and $FF;
ip4:=(ip shr 24) and $FF;
port1:=port and $FF;
port2:=(port shr 8) and $FF;
if fesPORT(s,ip1,ip2,ip3,ip4,port1,port2)=SOCKET_ERROR then
begin
     closesocket(sd);
     information:=('>ERROR '+inttostr(WSAGetLastError)+' : data socket not connected.');
     result:=INVALID_SOCKET;
     beeps;
     exit;
end;
result:=sd;
end;

function TFTPclient.fesPORT(s,ip1,ip2,ip3,ip4,port1,port2:integer):integer;
var
   buf:string;
   buf2:array[1..1024]of char;
   nr:integer;
begin
     //s com si fes un Flush...
     WSAAsyncSelect(s,handle,0,0);
     repeat
           nr:=recv(s,buf2,1024,0);
     until nr<0;
     //Fins aqu...
     buf:='PORT '  +inttostr(ip1)+','
                   +inttostr(ip2)+','
                   +inttostr(ip3)+','
                   +inttostr(ip4)+','
                   +inttostr(port1)+','
                   +inttostr(port2);
     information:=('>'+buf);
     if EnviarComanda(s,buf+#13+#10) then
     begin
          buf:=llegirlinia(s);
          if buf<>'' then
          begin
             information:=('--->'+buf);
          end;
          if cancelat then
          begin
              cancelat:=false;
              buf:=llegirlinia(s);
              cancelat:=true;
          end;
     end;
     result:=1;
end;

function TFTPclient.fesTYPE(s:integer;c:char):boolean;
var
   buf:string;
   nr:integer;
   buf2:array[1..1024]of char;
begin
     //s com si fes un Flush...
     WSAAsyncSelect(s,handle,0,0);
     repeat
           nr:=recv(s,buf2,1024,0);
     until nr<0;
     //Fins aqu...
     result:=false;
     if not EnviarComanda(s,'TYPE '+c+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>TYPE '+c);
     information:=('--->'+buf);
     if buf[1]='2' then
     begin
          result:=true;
     end;
end;

function TFTPclient.ComprobarREST(s:integer;ipactual:string):boolean;
var
   buf:string;
   nr:integer;
   buf2:array[1..1024]of char;
begin
     //s com si fes un Flush...
     WSAAsyncSelect(s,handle,0,0);
     repeat
           nr:=recv(s,buf2,1024,0);
     until nr<0;
     //Fins aqu...
     result:=false;
     if not EnviarComanda(s,'REST 0'+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>REST 0');
     information:=('--->'+buf);
     if buf[1]<>'3' then
     begin          //1,2,4,5
          information:=('-This Server can not resume broken downloads.');
          result:=false;
          exit;
     end else
     begin
          result:=true;
          information:=('-This Server can resume broken downloads.')
     end;
end;

procedure TFTPclient.beeps;
begin
     if fSoundfile='' then
        beep
     else
     begin
          if not playsound(pchar(fSoundFile),0,SND_FILENAME) then
             beep;
     end;
end;

function TFTPclient.LlegirLinia(s:integer):string;
var
   c:char;
   bufstr:string;
   nr:integer;
begin
     c:=#0;
     while c<>#10 do
     begin
          if EsperaWSA(s,FD_READ)<1 then
          begin
               ressetejaWSA(s);
               result:='';
               exit;
          end;
          nr:=recv(s,c,1,0);
          RessetejaWSA(s);
          if cancelat then
          begin
               information:=('--CANCELED--');
               exit;
          end;
          if nr=SOCKET_ERROR then
          begin
               //information:=('>Error '+inttostr(WSAGetLastError)+' reading server answer.');
               exit;
          end;
          if ((c<>#10) and (c<>#13)) then
          bufstr:=bufstr+c;
     end;
     result:=bufstr;
end;

function TFTPclient.EnviarComanda(s:integer;comanda:string):boolean;
var
   i,j,k,cont,len:integer;
   nr:longint;
   barray:array[1..1024]of char;
begin
     len:=length(comanda) div 1024;
     if length(comanda)mod 1024 <>0 then
        len:=len+1;
     result:=true;
     for i:=1 to len do
          begin
//          nr:=send(s,comanda[i],1,0);
            EsticEnWSA:=true;
            if WSAAsyncSelect(s,handle,1024,FD_WRITE or FD_CLOSE)=SOCKET_ERROR then
            begin
                 //error
                 result:=false;
                 exit;
            end;
            k:=1;
            cont:=1024;
            for j:=((i-1)*1024+1) to i*1024 do
            begin
                 if j<=length(comanda) then
                    barray[k]:=comanda[j]
                 else
                 begin
                      cont:=k-1;
                      break;
                 end;
                 k:=k+1;
            end;
            nr:=send(s,barray,cont,0);
            while EsticEnWSA do
            begin
                 if (cancelat) then
                 begin
                      result:=false;
                      exit;
                 end;
                 application.processmessages;
            end;
            if WSAAsyncSelect(s,handle,0,0)=SOCKET_ERROR then
            begin
                 result:=false;
                 exit;
            end;
            nr:=0;
            ioctlsocket(s,FIONBIO,nr);                   //blocking
     end;
end;

function TFTPclient.AcceptaSocket(s:integer):integer;
var
   addr:TSockAddrIn;
   sda,len:integer;
begin
     //es fa l'accept del socket s (que ser el retornat pel listen)
     result:=-1;
     len:=sizeof(addr);
     if EsperaWSA(s,FD_ACCEPT)<1 then
     begin
          ressetejaWSA(s);
          exit;
     end;
     sda:=accept(s,addr,len);
     RessetejaWSA(s);
     if sda=INVALID_SOCKET then
     begin
          information:=('>Error '+inttostr(WSAGetLastError)+' sending');
          beeps;
     end;
     closesocket(s);  //tanco el socket del listen
     result:=sda;
end;

function TFTPclient.RetornaAsteriscs(cad:string):string;
var
   i:integer;
begin
     result:='';
     for i:=1 to length(cad) do
         result:=result+'*';
end;

function TFTPclient.fesLIST(s:integer; dir,serv:string):string;
var
   buf:string;
   buf2:array[1..1024]of char;
   sd,sda,nr:integer;
   linies:integer;
begin
     //intento buidar tot el que em vingui per l'entrada
     //s com si fes un Flush...
     WSAAsyncSelect(s,handle,0,0);
     repeat
           nr:=recv(s,buf2,1024,0);
     until nr<=0;
     //Fins aqu...
     linies:=0;
     If EstoyEnEllo then
        exit;
     EstoyEnEllo:=true;
     result:='';
     buf:='1'; //pq entri al bucle
     //creo el socket de dades i actualitzo el PORT
     RessetejaWSA(s);    //per a assegurar-me que el socket s bloquejant de moment
     sd:=getListenSocket(s);
     if sd<>INVALID_SOCKET then
     begin
          festype(s,'A');
          if EnviarComanda(s,'LIST '+dir+#13+#10) then
          begin
               information:=('>LIST '+dir);
               buf:=llegirlinia(s);         //la 1 linia de les dues!!!!!!!
               if buf='' then               //si falla la torno a intentar llegir
                  if cancelat then
                  begin
                       cancelat:=false;
                       buf:=llegirlinia(s);
                       cancelat:=true;
                  end else
                       buf:=llegirlinia(s);
               if buf<>'' then
                  linies:=1;
               information:=('--->'+buf);
               sda:=AcceptaSocket(sd);
               if sda<>-1 then
               begin
                    TraduirLIST(sda);      //Passo el que rebo al Tree i al List
                    closesocket(sda);
               end;
          end;
     end  else
          linies:=2;
     buf:='';
     application.processmessages;
     if linies=0 then
     begin
          if cancelat then
          begin
               cancelat:=false;
               buf:=llegirlinia(s);
               cancelat:=true;
          end else
              buf:=llegirlinia(s);
          if buf<>'' then
          begin
             information:=('--->'+buf);
          end;
          linies:=1;
     end;
     if linies=1 then
     begin
          if cancelat then
          begin
               cancelat:=false;
               buf:=llegirlinia(s);
               cancelat:=true;
          end else
              buf:=llegirlinia(s);
          if buf<>'' then
          begin
             information:=('--->'+buf);
          end;
     end;
     if cancelat then
     begin
          EstoyEnEllo:=false;
          exit;
     end;

        fesCWD(s,dir);

     EstoyEnEllo:=false;
end;

function TFTPclient.ExtreuDirNet(dir:string):string;
var
   dirnet:string;
   i:integer;
begin
if length(dir)=0 then
begin
     result:='';
     exit;
end;

      if ((dir[length(dir)]<>'/')and(dir[length(dir)]<>'\')) then
      begin
         result:=dir;
      end else
      begin
          dirnet:='';
          for i:=1 to (length(dir)-1) do
          begin
               dirnet:=dirnet+dir[i];
          end;
          result:=dirnet;
      end;
end;

procedure TFTPclient.RessetejaWSA(s:integer);
var
   nr:longint;
begin
     if WSAAsyncSelect(s,handle,0,0)=SOCKET_ERROR then
     begin
          //error
          exit;
     end;
     nr:=0;
     ioctlsocket(s,FIONBIO,nr);                   //blocking
end;

function TFTPclient.EsperaWSA(s,event:integer):integer;
begin
     result:=1;//OK
     EsticEnWSA:=true;
     //activo el timer adequat
     if WSAAsyncSelect(s,handle,WM_USER,event)=SOCKET_ERROR then
     begin
         //error
         result:=-1;    //error
         exit;
     end;
     while EsticEnWSA do
     begin
          if (cancelat) then
          begin
               ressetejaWSA(s);
               result:=0; //cancelat
               exit;
          end;
              application.processmessages;
     end;
end;

procedure TFTPclient.TraduirLIST(s:integer);
var
   e,nr:integer;
   buf:array[0..1024] of char;
   fd:TFDSET;
   timeo:Ttimeval;
begin
//e:=1024;
LISTStr:='';
repeat
     buf:='';
     //primer comprobo que no hi hagi res en espera...
            RessetejaWSA(s);
            FD_ZERO(fd);
            FD_SET(s,fd);
            timeo.tv_usec:=0;
            timeo.tv_sec:=0;
            select(0,@fd,nil,nil{@fd2},@timeo);
     //information:=('nr select = '+inttostr(nr));
            if FD_ISSET(s,fd) then
            begin
                    nr:=1;
            end else
                nr:=-1;
     //information:=('nr ISSET = '+inttostr(nr));
      if nr>=0 then
{     if nr=0 then  }
             begin
               if EsperaWSAList(s,FD_READ)<1 then
               begin
                  ressetejaWSA(s);
                  closesocket(s);
                  exit;
               end;
             end;
     e:=recv(s,buf,1024,0);
     //information:=('e = '+inttostr(e));
     RessetejaWSA(s);
     if e=SOCKET_ERROR then
     begin
          beeps;
          information:=('Error receiving LIST');
          exit;
     end;
     if e>0 then
        LISTStr:=LISTStr+buf;
until e<=0;
//information:=('Tot Rebut...tradueixo');
RessetejaWSA(s);
closesocket(s);
//aqui ja est tot llegit
end;

function TFTPclient.fesCWD(s:integer;dir:string):boolean;
var
   buf:string;
   buf2:array[1..1024]of char;   
   nr:integer;
begin
     //s com si fes un Flush...
     WSAAsyncSelect(s,handle,0,0);
     repeat
           nr:=recv(s,buf2,1024,0);
     until nr<0;
     //Fins aqu...
     result:=true;
     if not EnviarComanda(s,'CWD '+dir+#13+#10) then
        exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>CWD '+dir);
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          result:=false;
          information:=('>Error changing Working Directory');
          exit;
     end;
     directorimostrat:=dir;
     if dir[length(dir)]<>'/' then
        directorimostrat:=dir+'/';
end;

function TFTPclient.fesCDUP(s:integer):boolean;
var
   buf:string;
begin
     result:=true;
     if not EnviarComanda(s,'CDUP'#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>CDUP');
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          result:=false;
          information:=('>Error changing to Parent Directory');
     end;
     //actualitzo el list i les variables
     fesPWD(s);
     if cancelat then
             exit;
     fesLIST(s,directorimostrat,'');
end;

function TFTPclient.fesMKD(s:integer;dir:string):boolean;
var
   buf:string;
begin
     result:=true;
     if not EnviarComanda(s,'MKD '+dir+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>MKD '+dir);
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          result:=false;
          information:=('>Error creating Directory');
     end;
end;

function TFTPclient.fesRMD(s:integer;dir:string):boolean;
var
   buf:string;
begin
     result:=true;
     if not EnviarComanda(s,'RMD '+dir+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>RMD '+dir);
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          result:=false;
//          information:=('>Error deleting Directory');
     end;
end;

function TFTPclient.EsperaWSAList(s,event:integer):integer;
begin
     result:=1;//OK
     EsticEnWSA:=true;
     //activo el timer adequat
     if WSAAsyncSelect(s,handle,WM_USERLIST,event or FD_CLOSE)=SOCKET_ERROR then
     begin
         //error
         result:=-1;    //error
         exit;
     end;
     while EsticEnWSA do
     begin
          if (cancelat) then
          begin
               ressetejaWSA(s);
               result:=0; //cancelat
               exit;
          end;     
              application.processmessages;
     end;
end;

procedure TFTPclient.WMUSERLIST(var Tm:tmessage);
begin
          EsticEnWSA:=false;
end;



procedure TFTPclient.WMUSER(var Tm:tmessage);
var
   ev,er:integer;
begin
     //per a que surti del bucle processmessages
     er:=WSAGETSELECTERROR(tm.lparam);
     if er<>0 then
        information:=(inttostr(er));
     ev:=wsagetselectevent(tm.lparam);
     if ev=FD_CLOSE then
     begin
               cancelat:=true;
               if (assigned(fclosed)) then fclosed(self);
               beeps;
     end;
          EsticEnWSA:=false;
end;

procedure tftpclient.WMUSERHOST(var Tm:tmessage);
begin
     esticenwsa:=false;
end;

procedure tftpclient.WndProc(var Message: TMessage);
begin
      with Message do
      if Msg = WM_USER then
      begin
           WMUSER(message);
      end else
          if Msg= WM_USERHOST then
          begin
               WMUSERHOST(message);
          end else
              if Msg= WM_USERLIST then
              begin
                   WMUSERLIST(message);
              end else
                  Result := DefWindowProc(FHandle, Msg, wParam, lParam);
          
end;

//----------------------------------------------------------------------

function tftpclient.MKD(DirName:string):boolean;
begin
     result:=fesMKD(socketmostrat,DirName);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.RMD(DirName:string):boolean;
begin
     result:=fesRMD(socketmostrat,DirName);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.CWD(DirName:string):boolean;
begin
     result:=fesCWD(socketmostrat,DirName);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.CDUP:boolean;
begin
     result:=fesCDUP(socketmostrat);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.FTPConnect:boolean;
begin
     result:=connectaraservidor(fhost,fuser,fpass,fport);
     if (not result and assigned(ferror) )then ferror(self);
     if (result and assigned(fconnected)) then fconnected(self);
end;

function tftpclient.LIST(DirName:string):string;
begin
     if DirName='' then
        DirName:=Directorimostrat;
     fesLIST(socketmostrat,dirname,fhost);
     result:=liststr;
end;

function TFTPclient.fesDELETEFILE(s:integer;nom:string):boolean;
var
   buf:string;
begin
     //esborra un FITXER
     result:=true;
     if not EnviarComanda(s,'DELE '+nom+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>DELE '+nom);
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          result:=false;
          information:=('>Error deleting file');
     end;
end;

function TFTPclient.fesQUIT(s:integer):boolean;
var
   buf:string;
begin
     //esborra un FITXER
     result:=true;
     if not EnviarComanda(s,'QUIT'+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>QUIT');
     information:=('--->'+buf);
     if length(buf)>1 then
       if buf[1]<>'2' then
       begin
          result:=false;
          information:=('>Error Logging Out');
       end;
     closesocket(s);
end;

function tftpclient.DeleteFile(FileName:String):boolean;
begin
     result:=fesDeleteFile(socketmostrat,Filename);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.Quit:boolean;
begin
     result:=fesquit(socketmostrat);
     if (not result and assigned(ferror) )then ferror(self);
end;

function TFTPclient.fesRENAME(s:integer;origen,desti:string):boolean;
var
   buf:string;
begin
     result:=true;
     if not EnviarComanda(s,'RNFR '+origen+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>RNFR '+origen);
     information:=('--->'+buf);
     if buf[1]<>'3' then
     begin
          result:=false;
          information:=('>Error creating Directory');
     end else
     begin
          if not EnviarComanda(s,'RNTO '+desti+#13+#10) then exit;
          buf:=llegirlinia(s);
          if cancelat then
             exit;
          information:=('>RNTO '+desti);
          information:=('--->'+buf);
          if buf[1]<>'2' then
          begin
               result:=false;
               information:=('>Error creating Directory');
          end

     end;
end;

function tftpclient.RenameFile(OldName,NewName:string):boolean;
begin
     result:=fesrename(socketmostrat,oldname,newname);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.PWD:string;
begin
     result:=fespwd(socketmostrat);
end;

function tftpclient.Open(Host,User,Pass:string;Port:integer):boolean;
begin
     result:=connectaraservidor(host,user,pass,port);
     if (not result and assigned(ferror) )then ferror(self);
     if (result and assigned(fconnected)) then fconnected(self);
end;

function TFTPclient.fesAbort(s:integer):boolean;
var
   buf:string;
begin
     result:=true;
     if not EnviarComanda(s,'ABOR'+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>ABOR');
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          result:=false;
          information:=('>Error creating Directory');
     end;
end;

function tftpclient.Abort:boolean;
begin
         result:=fesabort(socketmostrat);
         if (not result and assigned(ferror) )then ferror(self);
end;

procedure tftpclient.cancel;
begin
          cancelat:=true;
          EstoyEnEllo:=false;
end;

function TFTPclient.fesPUT(s:integer; arxiuorigen,arxiudesti:string):boolean;
var
   buf:string;
   i,nr,sd,sda,numread,fs:integer;
   temps:double;
   fit:file;
   paquet:array[1..TAM_PAQUET2]of byte;
   buf2:array[1..1024]of char;
begin
     seleccionatype(s,arxiuorigen);
     //s com si fes un Flush...
     WSAAsyncSelect(s,handle,0,0);
     repeat
           nr:=recv(s,buf2,1024,0);
     until nr<0;
     //Fins aqu...
     temps:=gettickcount;
     result:=true;
     buf:='1'; //pq entri al bucle
     sd:=getListenSocket(s);
     if sd=INVALID_SOCKET then
     begin
          information:=('>ERROR with listen socket.');
          result:=false;
          closesocket(sd);
          exit;
     end;

//-----------------------Aix s nou... lo del MODE i REST--------------
     {$I-}
     filemode:=0;
     assignfile(fit,arxiuorigen);
     reset(fit,1);
     {$I+}

     if ioresult<>0 then
     begin
          closefile(fit);
          closesocket(sd);
          information:=('>ERROR with file '+arxiuorigen);
          result:=false;
          exit;
     end;
     fs:=filesize(fit);
//----------------------------------------------------------------------
     //envio la comanda STOR
     if not EnviarComanda(s,'STOR '+arxiudesti+#13+#10) then exit;
     information:=('>STOR '+arxiudesti);
     buf:=llegirlinia(s);
     if cancelat then
          begin
               closefile(fit);
               closesocket(sd);
               result:=false;
               buf:=llegirlinia(s);//226;
               exit;
          end;
     information:=('--->'+buf);
     //si arribem aqui tot ha anat b
     if buf[1]<>'1' then
     begin
          closefile(fit);
          closesocket(sd);
          information:=('>ERROR with STOR command.');
          result:=false;
          exit;
     end;
     //faig l'accept
     sda:=AcceptaSocket(sd);
     if sda<0 then
     begin
          closefile(fit);
          closesocket(sda);
          if cancelat then
               begin
                    cancelat:=false;
                       buf:=llegirlinia(s);//falta la linia 226
                    cancelat:=true;
                    information:=('--->'+buf);
               end else
               begin
                    buf:=llegirlinia(s);//falta la linia 226
                    information:=('--->'+buf);
               end;
          information:=('>ERROR with accept socket.');
          result:=false;
          exit;
     end;
     //envio

     numread:=TAM_PAQUET2;
       while not eof(fit) do
       begin
          if numread<>0 then
          begin
               //Aix s per lo del Internet Mail: Es generen ms events del compte
               for i:=0 to TAM_PAQUET2 do
               begin
                    paquet[i]:=0;
               end;
               numread:=TAM_PAQUET2;
               blockread(fit,paquet,TAM_PAQUET2,numread);
          end else
               numread:=TAM_PAQUET2;
            EsticEnWSA:=true;
            nr:=send(sda,paquet,numread,0);
          if ((nr<0) and (WSAGetLastError=WSAEWOULDBLOCK))then
          begin
            if EsperaWSA(sda,FD_WRITE)<1 then
            begin
                 //error WSA
                 closefile(fit);
                 result:=false;
                 closesocket(sda);
                 if cancelat then
                 begin
                      cancelat:=false;
                      buf:=llegirlinia(s);//226
                      cancelat:=true;
                 end else
                     buf:=llegirlinia(s);//226
                 information:=('--->'+buf);
                 exit;
            end;
            if cancelat then
            begin
                 closefile(fit);
                 result:=false;
                 closesocket(sda);
                      cancelat:=false;
                      buf:=llegirlinia(s);//226
                      cancelat:=true;
                 information:=('--->'+buf);
                 exit;
            end;
                      nr:=send(sda,paquet,numread,0);
          end;
                      if ((nr<0) and (WSAGetLastError<>WSAEWOULDBLOCK))then
                      begin                  //error en el send
                           closesocket(sda);
                           if cancelat then
                           begin
                                cancelat:=false;
                                   buf:=llegirlinia(s);//falta la linia 226
                                cancelat:=true;
                                information:=('--->'+buf);
                                end else
                                begin
                                     buf:=llegirlinia(s);//falta la linia 226
                                     information:=('--->'+buf);
                                end;
                           closefile(fit);
                           result:=false;
                           exit;
                      end else
                      begin
                           if nr<0 then
                           begin
                                numread:=0;
                           end;
                      end;
            if cancelat then
            begin
                 closefile(fit);
                 result:=false;
                 closesocket(sda);
                      cancelat:=false;
                      buf:=llegirlinia(s);//226
                      cancelat:=true;
                 information:=('--->'+buf);
                 exit;
            end;
     end;
     closesocket(sda);
     closefile(fit);
         if cancelat then
         begin
             cancelat:=false;
             buf:=llegirlinia(s);//226
             information:=('--->'+buf);
             cancelat:=true;
             result:=false;
             exit;
         end else
             buf:=llegirlinia(s);//226
     information:=('--->'+buf);
     if buf<>'' then
     if buf[1]<>'2' then
     begin
          information:=('>ERROR with STOR command.');
          result:=false;
          exit;
     end;
     //s'ha transms correctament
     temps:=(gettickcount-temps) / 1000; //segons utilitzats
     information:=('>File '''+arxiudesti+''' transmitted OK.');
     information:=(')Time needed = '+floattostr(temps)+' secs.');
     if fs/temps<1000 then
     begin
        temps:=round((fs/temps)*1000)/1000;
        information:=(')Speed = '+floattostr(temps)+' Bytes/sec');
     end else
     begin
        temps:=round((fs/temps))/1000;
        information:=(')Speed = '+floattostr(temps)+' KBytes/sec');
     end;
     result:=true;
     if assigned(ffileput) then ffileput(self);
end;

function TFTPclient.fesGET(s:integer; arxiuorigen,arxiudesti:string):boolean;
var
   totalstr,buf:string;
   rebuts,total,i,sd,sda,numread,fs:integer;
   nr:longint;
   temps:double;
   fit:file;
   paquet:array[1..TAM_PAQUET]of byte;
   buf2:array[1..1024]of char;
begin
     seleccionatype(s,arxiuorigen) ;
     //s com si fes un Flush...
     WSAAsyncSelect(s,handle,0,0);
     repeat
           nr:=recv(s,buf2,1024,0);
     until nr<0;
     //Fins aqu...
     temps:=gettickcount;
     result:=true;
     buf:='1'; //pq entri al bucle
     //intento obrir l'arxiu

         if (fileexists(arxiudesti)) then
         begin
            if application.messagebox(pchar('The file '+arxiudesti+' already exists.'+#13+'Do you want to replace it?'),'Shuttle FTP',MB_YESNO)=IDNO then
               exit;
         end;

     filemode:=2;
     assignfile(fit,arxiudesti);

     //creo el socket de dades i actualitzo el PORT
     sd:=getListenSocket(s);
     if sd=INVALID_SOCKET then
     begin
          closesocket(sd);
          information:=('>ERROR with listen socket.');
          result:=false;
          exit;
     end;
//-----------------------Aix s nou... lo del MODE i REST--------------
     {$I-}
     rewrite(fit,1);
     {$I+}
//----------------------------------------------------------------------
     if ioresult<>0 then
     begin
          closefile(fit);
          closesocket(sd);
          information:=('>ERROR with file '+arxiudesti);
          result:=false;
          exit;
     end;
    // fs:=filesize(fit);
     //envio la comanda RETR
     if not EnviarComanda(s,'RETR '+arxiuorigen+#13+#10) then exit;
     information:=('>RETR '+arxiuorigen);
     buf:=llegirlinia(s);
     if cancelat then
     begin
          buf:=llegirlinia(s);//226;
          closesocket(sd);
          closefile(fit);
          result:=false;
          exit;
     end;
     information:=('--->'+buf);
     if buf[1]<>'1' then
     begin
          closefile(fit);
          closesocket(sd);
          information:=('>ERROR with RETR command.');
          result:=false;
          exit;
     end;
     i:=1;
     while ((buf[i]<>'(')and(i<length(buf))) do
           i:=i+1;
     i:=i+1;
     totalstr:='';
     while ((buf[i]<>' ')and(i<length(buf))) do
     begin
           totalstr:=totalstr+buf[i];
           i:=i+1;
     end;
     total:=strtoint(totalstr);
     //si arribem aqui tot ha anat b
     sda:=AcceptaSocket(sd);
     if sda<0 then
     begin
          closefile(fit);
          closesocket(sda);
               if cancelat then
               begin
                    cancelat:=false;
                       buf:=llegirlinia(s);//falta la linia 226
                    cancelat:=true;
                    information:=('--->'+buf);
               end else
               begin
                    buf:=llegirlinia(s);//falta la linia 226
                    information:=('--->'+buf);
               end;
          information:=('>ERROR with accept socket.');
          result:=false;
          exit;
     end;
     //envio
     rebuts:=0;
     while rebuts<total do
     begin
          for i:=0 to TAM_PAQUET do
              paquet[i]:=0;
     nr:=1;
     ioctlsocket(sda,FIONBIO,nr);                   //no blocking
     numread:=recv(sda,paquet,TAM_PAQUET,0);
     RessetejaWSA(sda);
     application.processmessages;
          if numread<0 then
          begin
            if EsperaWSA(sda,FD_READ)<1 then
            begin
               closefile(fit);
               ressetejaWSA(sda);
               closesocket(sda);
               result:=false;
               if cancelat then
               begin
                    cancelat:=false;
                       buf:=llegirlinia(s);//falta la linia 226
                    cancelat:=true;
                    information:=('--->'+buf);
               end else
               begin
                    buf:=llegirlinia(s);//falta la linia 226
                    information:=('--->'+buf);
               end;

              exit;
            end;
            if cancelat then
            begin
               closefile(fit);
               result:=false;
               closesocket(sda);
               cancelat:=false;
                  buf:=llegirlinia(s);//falta la linia 226
               cancelat:=true;
               information:=('--->'+buf);
               exit;
            end;
            numread:=recv(sda,paquet,TAM_PAQUET,0);
            RessetejaWSA(sda);
          end;
          if numread=SOCKET_ERROR then
          begin
               closefile(fit);
               information:=('>ERROR receiving.');
               result:=false;
               closesocket(sda);
               if cancelat then
               begin
                    cancelat:=false;
                       buf:=llegirlinia(s);//falta la linia 226
                    cancelat:=true;
                    information:=('--->'+buf);
               end else
               begin
                    buf:=llegirlinia(s);//falta la linia 226
                    information:=('--->'+buf);
               end;
               exit;
          end;
          rebuts:=rebuts+numread;
          blockwrite(fit,paquet,numread);

     end;
     fs:=filesize(fit);
     closefile(fit);
     closesocket(sda);
     if cancelat then
     begin
          cancelat:=false;
          buf:=llegirlinia(s); //226
          cancelat:=true;
     end else
         buf:=llegirlinia(s);
     if cancelat then
     begin
               result:=false;
               exit;
     end;
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          information:=('>ERROR with RETR command.');
          result:=false;
          exit;
     end;
     //s'ha transms correctament
     temps:=(gettickcount-temps) / 1000; //segons utilitzats
     information:=('>File '''+arxiudesti+''' transmitted OK.');
     information:=(')Time needed = '+floattostr(temps)+' secs.');
     if fs/temps<1000 then
     begin
        temps:=round((fs/temps)*1000)/1000;
        information:=(')Speed = '+floattostr(temps)+' Bytes/sec');
     end else
     begin
        temps:=round((fs/temps))/1000;
        information:=(')Speed = '+floattostr(temps)+' KBytes/sec');
     end;
     result:=true;
     if assigned(ffileget) then ffileget(self);
end;

procedure TFTPclient.SeleccionaTYPE(s:integer;arxiu:string);
begin
     case ftype of
          ASCII :     fesTYPE(s,'A');
          Binary :    fesTYPE(s,'I');
          else
          begin
            if ((lowercase(extractfileext(arxiu))='.txt')or
              (lowercase(extractfileext(arxiu))='.htm')or
              (lowercase(extractfileext(arxiu))='.html')) then
            begin
              fesTYPE(s,'I');
            end else
            begin
              fesTYPE(s,'I');
            end;
          end;
     end;
end;

function tftpclient.Put(LocalFile,RemoteFile:string):boolean;
begin
     result:=fesPut(socketmostrat,localfile,remotefile);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.Get(RemoteFile,LocalFile:string):boolean;
begin
     result:=fesget(socketmostrat,remotefile,localfile);
     if (not result and assigned(ferror) )then ferror(self);
end;

function TFTPClient.fesSYST(s:integer):string;
var
   buf:string;
begin
     if not EnviarComanda(s,'SYST'+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>SYST');
     information:=('--->'+buf);
     result:='';
     if buf[1]<>'2' then
     begin
          beeps;
          exit;
     end;
     result:=buf;
end;

function TFTPclient.fesNOOP(s:integer):boolean;
var
   buf:string;
begin
     result:=false;
     if not EnviarComanda(s,'NOOP'+#13+#10) then exit;
     buf:=llegirlinia(s);
     if cancelat then
             exit;
     information:=('>NOOP');
     information:=('--->'+buf);
     if buf[1]<>'2' then
     begin
          beeps;
          result:=false;
          exit;
     end;
     result:=true;
end;

function tftpclient.System:string;
begin
     result:=fessyst(socketmostrat);
end;

function tftpclient.NOOP:boolean;
begin
     result:=fesnoop(socketmostrat);
     if (not result and assigned(ferror) )then ferror(self);
end;

function tftpclient.CustomCommand(command:string):string;
var
   buf,buftot:string;
   i:integer;
   cad:string;
begin
     cad:=command;
     if cad<>'' then
     begin
     cancelat:=false;
          //fins aqu...
          if not EnviarComanda(socketmostrat,cad+#13+#10) then exit;
          information:=('>'+cad);
          buf:='----';
          buftot:='';
          while (buf[4]='-')or((buf[1]<'1')or(buf[1]>'5')) do
          begin
               buf:=llegirlinia(socketmostrat);
               if cancelat then
                  exit;
               if buf[1]='2' then
               begin
                    for i:=6 to length(buf) do
                    begin
                         if buf[i]='"' then break;
                    end;
               end;
               if (buf[4]='-')or((buf[1]<'1')or(buf[1]>'5'))then
                  buftot:=buftot+buf;
          end;
          information:=('--->'+buf);
          result:=buftot;
     end;
end;

procedure tftpclient.setinfo(i:string);
begin
     finformation:=i;
     if assigned(finformationevent) then finformationevent(self,finformation);
end;

function FD_ISSET(Socket: TSocket; var FDSet: TFDSet): Boolean;
begin
  Result := WSAFDIsSet(Socket, FDSet);
end;

procedure FD_SET(Socket: TSocket; var FDSet: TFDSet);
begin
  if FDSet.fd_count < FD_SETSIZE then
  begin
    FDSet.fd_array[FDSet.fd_count] := Socket;
    Inc(FDSet.fd_count);
  end;  
end;

procedure FD_ZERO(var FDSet: TFDSet);
begin
  FDSet.fd_count := 0;
end;

function WSAFDIsSet;      external     winsocket name '__WSAFDIsSet';

end.
